From 85658d2ea3541d63930b3dd81d368d6d00c7a0b1 Mon Sep 17 00:00:00 2001
From: Peter Eisentraut <peter@eisentraut.org>
Date: Fri, 12 May 2017 14:43:35 -0400
Subject: [PATCH] Update about new version numbering

---
 templates/support/versioning.html | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/templates/support/versioning.html b/templates/support/versioning.html
index 4c40dea..996de12 100644
--- a/templates/support/versioning.html
+++ b/templates/support/versioning.html
@@ -9,7 +9,7 @@
 </p>
 
 <p>
-PostgreSQL major releases include new features and occur roughly once every year. A major release is numbered by increasing either the first or second part of the version number, e.g. 9.1 to 9.2.
+PostgreSQL major releases include new features and occur roughly once every year. Beginning with version 10, a major release is indicated by increasing the first part of the version, e.g. 10 to 11.  Before version 10, a major release was indicated by increasing either the first or second part of the version number, e.g. 9.5 to 9.6.
 </p>
 
 <p>
@@ -17,7 +17,7 @@ Major releases usually change the internal format of system tables and data file
 </p>
 
 <p>
-Minor releases are numbered by increasing the third part of the version number, e.g. 9.2.3 to 9.2.4. The PostgreSQL team only adds bug fixes to minor releases. All users should upgrade to the most recent minor release as soon as possible. While upgrades always have some risk, PostgreSQL minor releases fix only frequently-encountered, <a href="/support/security">security</a>, and data corruption bugs to reduce the risk of upgrading. <i>The community considers not upgrading to be riskier than upgrading</i>.
+Minor releases are numbered by increasing the last part of the version number.  Beginning with version 10, this is the second part of the version number, e.g. 10.0 to 10.1; for older versions this is the third part of the version number, e.g. 9.5.3 to 9.5.4. The PostgreSQL team only adds bug fixes to minor releases. All users should upgrade to the most recent minor release as soon as possible. While upgrades always have some risk, PostgreSQL minor releases fix only frequently-encountered, <a href="/support/security">security</a>, and data corruption bugs to reduce the risk of upgrading. <i>The community considers not upgrading to be riskier than upgrading</i>.
 </p>
 
 <p>

base-commit: fa07ed84b8708240264fe9f091b2087b7f872b8c
-- 
2.12.2