diff --git a/doc/src/sgml/release-10.sgml b/doc/src/sgml/release-10.sgml
index eff1fbc719..7af081e79e 100644
--- a/doc/src/sgml/release-10.sgml
+++ b/doc/src/sgml/release-10.sgml
@@ -139,17 +139,6 @@ <title>Migration to Version 10</title>
 
     <listitem>
      <!--
-     Author: Peter Eisentraut <peter_e@gmx.net> 2017-05-12 [c1a7f64b4]
-     Replace "transaction log" with "write-ahead log"
-     -->
-     <para>
-      Rename<acronym>WAL</>-related functions and views to use <literal>lsn</>
-      instead of <literal>location</> (David Rowley)
-     </para>
-    </listitem>
-
-    <listitem>
-     <!--
      Author: Andres Freund <andres@anarazel.de>
      2017-01-18 [69f4b9c85] Move targetlist SRF handling from expression evaluation 
      Author: Tom Lane <tgl@sss.pgh.pa.us>
@@ -190,6 +179,27 @@ <title>Migration to Version 10</title>
     <listitem>
      <!--
      Author: Peter Eisentraut <peter_e@gmx.net>
+     2017-02-13 [8df9bd0b4] Change logical replication pg_hba.conf use
+     -->
+     <para>
+      Change how logical replication
+      uses <link linkend="auth-pg-hba-conf"><filename>pg_hba.conf</filename></link>.
+     </para>
+
+     <para>
+      In previous releases, a logical replication connection required
+      the <literal>replication</literal> keyword in the database column.  As
+      of this release, logical replication matches a normal entry with a
+      database name or keywords such as <literal>all</literal>.  Physical
+      replication continues to use the <literal>replication</literal> keyword.
+      Since built-in logical replication is new in this release as well, this
+      change only affects users of third-party logical replication plugins.
+     </para>
+    </listitem>
+
+    <listitem>
+     <!--
+     Author: Peter Eisentraut <peter_e@gmx.net>
      2017-01-14 [05cd12ed5] pg_ctl: Change default to wait for all actions
      -->
     <para>